'use strict';

angular.module('adf.widget.electre.lavoisier')
.directive(
    'lavoisierHtmlContent',
    [
        "lavoisierHttpRequestService", "parserService", "domService",
        function (lavoisierHttpRequestService, parserService, domService) {
            var templateUrl;

            function addDom (scope, element, attrs) {
                if (element.children().length > 0) element.empty();
                scope.control.processing();
                
                lavoisierHttpRequestService.getResult_2({ url : scope.control.config.url, params : scope.control.config.params })
                .then(
                    function (value) {
                        var html = parserService.htmlDomFromString(value);
                        if (element.children().length > 0)element.empty();

                        var container = html.getElementById("wrapper");
                        container.className = "";

                        element.append(container);
                    },
                    function () {
                        scope.requestFailed = true;
                        throw "An error has occurred during the request. Please verify you have entered valid info.";
                    }
                ).then(
                    function () {
                        scope.control.success();
                    }, function () {
                        if (scope.requestFailed)        scope.control.requestFailed();
                        else                            scope.control.processingFailed();
                    }
                );
            }

            return {
                scope : {
                    control : '='
                },
                link : function (scope, element, attrs) {
                    scope.requestFailed = false;
                    addDom(scope, element, attrs);
                }
            };
        }
    ]
);